precision mediump float;

#define NUM_TEXTURES 1


uniform bool enable_fog; 
uniform bool enable_tex[NUM_TEXTURES];
uniform sampler2D a_Texture0;
uniform vec4 fog_Color;
uniform float FogDisRate;	//Ч
uniform float Rate2;	//Ũ

uniform bool	m_bTrans;	//Ƿͬ
uniform float	m_TransRate;	//͸


varying vec2 v_texcoord[NUM_TEXTURES];
varying vec4 v_back_color;

varying float posz;
varying float v_fog_factor;


void main()
{

	if (enable_fog)
	{
		//vec3 fogColor=vec3(0.05,0.3,0.6);
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
		float f = clamp(posz*FogDisRate, 0.0, Rate2);
		gl_FragColor.xyz=gl_FragColor.xyz*(1.0-f)+fog_Color.xyz*f;
	}
	else
	{
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
		
	}
	if (m_bTrans)
	{
		gl_FragColor.w*=m_TransRate;
	}
	
	
	/*float rate=posz*0.002;
	if (rate<0.0) rate=0.0;
	if (rate>0.8) rate=0.8;
	if (rate<1.0)
	{
		vec4 texColor=texture2D(a_Texture0, v_texcoord[0]);
		gl_FragColor=texColor*v_back_color*(1.0-rate);
	}*/
	
	
	/*float rate=clamp(posz*0.002, 0.0, 0.8);
	vec4 texColor=texture2D(a_Texture0, v_texcoord[0]);
	gl_FragColor=texColor*v_back_color*(1.0-rate);*/
	
	
	/*if (enablefog)
	{
		//vec3 fogColor=vec3(0.05,0.3,0.6);
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
		float f = clamp(posz*FogDisRate, 0.0, Rate2);
		gl_FragColor.xyz=gl_FragColor.xyz*(1.0-f)+fogColor.xyz*f;
	}
	else
	{
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
	}*/
	
	/*if (enable_fog)
	{
		//vec3 fogColor=vec3(0.05,0.3,0.6);
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
		float f = clamp(posz*FogDisRate, 0.0, Rate2);
		gl_FragColor.xyz=gl_FragColor.xyz*(1.0-f)+fog_Color.xyz*f;
	}
	else
	{
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
	}*/

	
	/*vec4 texColor=texture2D(a_Texture0, v_texcoord[0]);
	gl_FragColor=texColor*v_back_color;
	
	vec3 fogColor=vec3(0.05,0.3,0.6);
	gl_FragColor.xyz+=fogColor;*/
	
	//gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
	
	//vec3 fogColor=vec3(0.05,0.3,0.6);
	//gl_FragColor.xyz+=fogColor;
	
	
	/*if (enable_tex[0])
	{
		//gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color+fogColor;
		gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color*v_fog_factor+fogColor*(1.0-v_fog_factor);
	}
	else
		gl_FragColor=v_back_color+fogColor;*/
		
	//vec3 fogColor=vec3(0.05,0.3,0.6);
	/*vec3 fogColor=vec3(1.00,1.0,1.0);
	gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
	float f = clamp(v_fog_factor*, 0.0, 1.0);
	//float f = clamp(posz*0.008, 0.0, 1.0);
	gl_FragColor.xyz=gl_FragColor.xyz*f+fogColor.xyz*(1.0-f);
	
	//gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
	//float f = clamp(v_fog_factor, 0.0, 0.7);
	//gl_FragColor.xyz=gl_FragColor.xyz*f+fogColor.xyz*(1.0-f);*/
	
	/*float f=posz*0.02;
	if (f<0.0) f=0.0;
	//if (f<1.0)
	gl_FragColor.xyz=gl_FragColor.xyz*(1.0-f)+fogColor.xyz*f;*/
	
	//gl_FragColor=texture2D(a_Texture0, v_texcoord[0])*v_back_color;
}